Page MenuHomePhabricator

Set "E-mail me when a page or file on my watchlist is changed" (enotifwatchlistpages) to true by default for new Wikimedia users
Open, NormalPublic

Description

This is the (hopefully) last split from T30026.

This preference is not true by default in our config, nor in the default MediaWiki config, which doesn't make much sense; I checked inspired by something jdforrester wrote me: «I assumed that when I created an account "e-mail me about pages I watch" was switched on, as per most other instances nowadays». They should indeed!

So, the plan is still the same as in T30026#330432 by Roan, except that $wgEnotifWatchlist is currently true:

  1. Add (or hack in) a MW config var that makes it so the enotifwatchlistpages preference is visible, but not functional (i.e. enabling it doesn't actually cause e-mails to be sent). This will stop watchlist e-mail notifs (similar to disabling $wgEnotifWatchlist) but preserve the preference.
  2. Enable this config var.
  3. Compile a list of users that have the preference enabled.
  4. Set $wgDefaultUserOptions['enotifwatchlistpages'] = 1; . The preference is now enabled for all users, but because it's not functional, there is no deluge of e-mail notifications overwhelming our mail system.
  5. Using a maintenance script, set the preference to 0 for each userindividually, excluding users that already had it enabled (from the list madein step 3) and invalidating the user cache for each user that it touches. Running this will probably take a while (a few hours?) on a large wiki like enwiki.
  6. Undo step 2 (disable the config var). The preference is now functional again and enabled for the same set of users, but it will now also be enabled by default for new users

This seemed to be harder than T38316 as first step, but unlike T38316 it can't possibly give any problem with bots as long as their watchlists are empty, and it won't affect existing users (or whatever subset of them we choose) thanks to the maintenance script.

New users will still have to manually enable enotifwatchlist but won't have to understand the watchlist before starting to use it...

See Also:

Details

Reference
bz38796

Event Timeline

bzimport raised the priority of this task from to Normal.Nov 22 2014, 1:08 AM
bzimport set Reference to bz38796.
bzimport added a subscriber: Unknown Object (MLST).
Nemo_bis created this task.Jul 29 2012, 6:06 PM

swalling wrote:

(In reply to comment #0)

This is the (hopefully) last split from bug 28026.
This preference is not true by default in our config, nor in the default
MediaWiki config, which doesn't make much sense; I checked inspired by
something jdforrester wrote me: «I assumed that when I created an account
"e-mail me about pages I watch" was switched on, as per most other instances
nowadays». They should indeed!
So, the plan is still the same as in bug 28026 comment 60 by Roan, except that

$wgEnotifWatchlist is currently true:

  1. Add (or hack in) a MW config var that makes it so the enotifwatchlistpages

preference is visible, but not functional (i.e. enabling it doesn't actually
cause e-mails to be sent). This will stop watchlist e-mail notifs (similar to
disabling $wgEnotifWatchlist) but preserve the preference

  1. Enable this config var
  2. Compile a list of users that have the preference enabled
  3. Set $wgDefaultUserOptions['enotifwatchlistpages'] = 1; . The preference is

now enabled for all users, but because it's not functional, there is no deluge
of e-mail notifications overwhelming our mail system

  1. Using a maintenance script, set the preference to 0 for each user

individually, excluding users that already had it enabled (from the list made
in step 3) and invalidating the user cache for each user that it touches.
Running this will probably take a while (a few hours?) on a large wiki like
enwiki

  1. Undo step 2 (disable the config var). The preference is now functional again

and enabled for the same set of users, but it will now also be enabled by

default for new users

This seemed to be harder than bug 36316 as first step, but unlike bug 36316 it
can't possibly give any problem with bots as long as their watchlists are
empty, and it won't affect existing users (or whatever subset of them we
choose) thanks to the maintenance script.
New users will still have to manually enable enotifwatchlist but won't have to
understand the watchlist before starting to use it...

+1 one to all of Nemo's comments. Please fulfill this request. :)

If we do this, we should make it obvious how to turn it off. It could be good for new users, but overwhelming once someone has watched a large number of articles.

(In reply to comment #2)

If we do this, we should make it obvious how to turn it off. It could be
good
for new users, but overwhelming once someone has watched a large number of
articles.

In the standard enotif, it is obvious. [[translatewiki:MediaWiki:Enotif_body/en]].

aravikn wrote:

Could someone assign this bug to me?

Aravind: If you can confirm that you have found the configuration files of Wikipedia in Gerrit and the place where to fix this (feel free to post a link here), sure. :)

(In reply to comment #5)

Aravind: If you can confirm that you have found the configuration files of
Wikipedia in Gerrit and the place where to fix this (feel free to post a link
here), sure. :)

Note, it requires more than just changing $wgDefaultUserOptions, due to the "for new users" part (changing a default preference/option affects anyone without an override for that preference, not just new users).

The MediaWiki default was just changed per bug 45022.

For anyone wondering, 01b32f67c3d04fa29edc02605abcbae6037297b4 explicitly sets enotifwatchlistpages off for the Wikimedia cluster. That way we can solve this separately (this bug requests to do it just for new users, which is different from the core solution).

tomasz removed a project: Shell.Feb 23 2015, 7:58 PM
tomasz set Security to None.
Restricted Application added subscribers: Matanya, Aklapper. · View Herald TranscriptAug 17 2015, 2:02 AM
Meno25 removed a subscriber: Meno25.Feb 8 2016, 7:37 PM
Restricted Application added a subscriber: JEumerus. · View Herald TranscriptFeb 8 2016, 7:37 PM
MarcoAurelio changed the task status from Open to Stalled.Mar 6 2016, 3:57 PM
MarcoAurelio lowered the priority of this task from Normal to Low.
MarcoAurelio removed a subscriber: wikibugs-l-list.
Dereckson lowered the priority of this task from Low to Lowest.Apr 14 2016, 11:50 AM
Dereckson added a subscriber: Dereckson.

If someone is planning to work on this, please raise the priority to low (or normal if you're going to do it soon), see Z398.

No work is needed here, AFAICS.

Mattflaschen-WMF changed the task status from Stalled to Open.EditedApr 21 2016, 4:05 PM

This was requesting it for new users, but Nemo updated it for all users in T47022: Make preference "Email me when a page or file on my watchlist is changed" true by default.

As Nemo said, this doesn't need to be addressed further unless there's something wrong with that solution.

Mattflaschen-WMF closed this task as Resolved.Apr 21 2016, 4:06 PM
Mattflaschen-WMF assigned this task to Nemo_bis.
Nemo_bis reopened this task as Open.Apr 21 2016, 5:38 PM

That's only for MediaWiki core, not Wikimedia which still has:

// Temporary override: WMF is not hardcore enough to enable this.
// See T37785, T38316, T47022 about it.
$wgDefaultUserOptions['watchdefault'] = 0;
$wgDefaultUserOptions['enotifwatchlistpages'] = 0;
$wgDefaultUserOptions['usenewrc'] = 0;
$wgDefaultUserOptions['extendwatchlist'] = 0;

"No work is needed" in the sense that nothing special needs to be done, just flip the switch.

Nemo_bis removed Nemo_bis as the assignee of this task.Apr 21 2016, 5:38 PM
Nemo_bis raised the priority of this task from Lowest to Normal.

Okay let's start a discussion in meta:Wikimedia Forum to see if it's actionable or if we need a RFC.

Discussion opened on meta. Wikimedia Forum (diff). We'll see what feedback we can gather there.

Mattflaschen-WMF renamed this task from Set "E-mail me when a page or file on my watchlist is changed" (enotifwatchlistpages) to true by default for new users to Set "E-mail me when a page or file on my watchlist is changed" (enotifwatchlistpages) to true by default for Wikimedia users.May 11 2016, 6:42 PM
Mattflaschen-WMF renamed this task from Set "E-mail me when a page or file on my watchlist is changed" (enotifwatchlistpages) to true by default for Wikimedia users to Set "E-mail me when a page or file on my watchlist is changed" (enotifwatchlistpages) to true by default for mew Wikimedia users.
Mattflaschen-WMF renamed this task from Set "E-mail me when a page or file on my watchlist is changed" (enotifwatchlistpages) to true by default for mew Wikimedia users to Set "E-mail me when a page or file on my watchlist is changed" (enotifwatchlistpages) to true by default for new Wikimedia users.

Sorry for mixing up core vs. Wikimedia in my above comment.

Also, the difficulty here depends on whether it's actually done only for new users (as originally requested), or for all users.

whether it's actually done only for new users (as originally requested)

IMHO not necessary, can be for all users: those who receive too much mail will quickly disable, but we can't predict what is too much for whom. But my original request was changed by another person in the bug from which this has been split.

He7d3r updated the task description. (Show Details)May 15 2016, 12:29 AM

whether it's actually done only for new users (as originally requested)

IMHO not necessary, can be for all users: those who receive too much mail will quickly disable, but we can't predict what is too much for whom. But my original request was changed by another person in the bug from which this has been split.

I don't think we can just do it. We have some users with absolutely ridiculous watchlist sizes. For example, ClueBot NG on enwiki has 2506182 (two and a half million) pages in its watchlist at the moment; File Upload Bot (Magnus Manske) on commonswiki has 1820788 (one point eight million) pages in its watchlist. Both of these accounts have a verified email set (Special:EmailUser works for them).

If we were to send an email for every change to these pages to them, even for a short time before the operators realize what is going on, it would probably be disruptive to whoever the email points at, and potentially also disruptive for Wikimedia (I wonder how many emails per second we can send…).

The numbers here were generated with this query, if anyone with access to Analytics replicas wants to verify:

select user_name, c from (select wl_user, count(*) as c from watchlist group by wl_user) watchlist2
left join user on wl_user=user_id
where user_email_authenticated is not null
order by c desc limit 10;
Ricordisamoa added a comment.EditedMay 19 2016, 5:06 AM
In T40796#2286301, @Mattflaschen wrote:

Also, the difficulty here depends on whether it's actually done only for new users (as originally requested), or for all users.

Not for all users of course, nor for new users hopefully. → What's the carbon footprint of ... email?

whether it's actually done only for new users (as originally requested)

IMHO not necessary, can be for all users: those who receive too much mail will quickly disable, but we can't predict what is too much for whom. But my original request was changed by another person in the bug from which this has been split.

I don't think we can just do it.

Good point.

Someone should email the bots over a million and ask them to clear their watchlist with https://en.wikipedia.org/wiki/Special:EditWatchlist/clear .

I wonder how ClueBot NG got so many to begin with. "Add pages I create and files I upload to my watchlist" shouldn't have caused that, since I don't know why it would be creating pages.

I don't know if it will actually break anything, but it's probably good to trim down the watchlist table and avoid unnecessary emails.